<?php
/**
 * @package heiv-gallery_3
 * @author www.heiv.fr 
 * @version 0.2.3
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.2.3
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010-2011 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


if ( ! defined( 'ABSPATH' ) ) 
        die( "Can't load this file directly" );

define('NL','<br>');
define('HR','<hr>');
 
$loading = true;
$path = ini_get('include_path');
$ret = ini_set('include_path', dirname(__FILE__) . '/pear/'.PATH_SEPARATOR.$path);
if($ret && file_exists(dirname(__FILE__) .'/pear/HTTP/Request.php') ){
	require_once(dirname(__FILE__) . '/pear/HTTP/Request.php');
}
else {
	printf('<h2>Impossible to load required libraries (PEAR and PEAR/HTTP/Request)!<br/> Please check if ./pear exist or install this libraries in you php\'s share directory. </h2>');
	$loading=false;
}

abstract class heiv_gallery_3_render {
	protected $pattern_css_photo='';
	protected $patter_js_gallery='';

	function get_render($infos) {
		$ret = '';
		if( !is_null($infos) && !is_null($this->options) ) {
			if( isset($infos->entity->type) ) {
				switch($infos->entity->type) {
					case 'photo' : {
						$ret = $this->get_render_photo($infos);
						break;
					}
					case 'album' : {
						$ret = $this->get_render_album($infos);
						break;
					}
					case 'movie' : {
						break;
					}
				}
			}
		}
		return $ret;
	}

	function get_render_photo($infos) { return null; }
	function get_render_album($infos){ return null; }
	function get_css_photo(){ return null; }
	function get_js_gallery(){ return null ;}

	public function register_wp_css(){}
	public function register_wp_js(){}
}

class heiv_gallery_3 {

	protected $ticket='';
	protected $options = null;
	protected $valid_render = array('default','smoothgallery','lightbox');

	protected $fct_required = array(
						'get_render_photo' => 1,
						'get_render_album' => 1,
						'get_css_photo' => 0,
						'get_js_gallery' => 0,
						'register_wp_css' => 0,
						'register_wp_js' => 0
					);
	protected $renderer=null;

	function __construct() {
	// the_posts gets triggered before wp_head in order to load CSS + JS
		if(!strstr($_SERVER['REQUEST_URI'],'wp-admin')) {
			add_filter('the_posts', array($this,'conditionally_add_scripts_and_styles') );
		}

		add_action( 'admin_init', array( $this, 'action_admin_init' ) );
	// hook for the ajax response during edit posts and pages
		add_action('wp_ajax_heiv_gallery_3_populate_tree', array($this,'ajax_hg3_populate_tree_cb') );
		add_action('wp_ajax_heiv_gallery_3_get_renderer', array($this,'ajax_hg3_get_renderer') );
	// hook for the plugin's config
		add_action('admin_menu',array($this,'config_admin_menu') );
	// hook for the binding tag
		add_shortcode('hgallery3',array($this,'hg3_display') );
		
		$this->options = get_option('HeivGallery3PP');

	}

	function conditionally_add_scripts_and_styles($posts){
		if (empty($posts)) return $posts;
	 
		$render_found = array();
		array_push($render_found,$this->options['g3_render_single_img']);
		foreach ($posts as $post) {
			$matches=array();
			preg_match_all("#\[hgallery3.*\]#",$post->post_content,$matches);
			foreach($matches[0] as $match) {
				$matches2 = array();
				if( 1 <= preg_match_all("#render=\"(.*)\"#",$match,$matches2) ) {
					foreach($matches2[1] as $m) {
						array_push($render_found,$m);
					}
					unset($matches2);
				}
			}

			unset($matches);
		}
		$render_found = array_unique($render_found);
		if (!is_null($render_found) ) {
			foreach($render_found as $render) {
				if(is_file(dirname(__FILE__).'/skins/'.$render.'/'.$render.'.inc.php')) {
					require_once(dirname(__FILE__).'/skins/'.$render.'/'.$render.'.inc.php');
					$methods = get_class_methods('heiv_gallery_3_render_' . $render );
					if( in_array( 'register_wp_js' , $methods)) {
						$class = 'heiv_gallery_3_render_' . $render;
						$instance = new $class();
						$instance->register_wp_js();
						unset($class);
						unset($instance);
					}
					if( in_array( 'register_wp_css' , $methods )) {
						$class = 'heiv_gallery_3_render_' . $render;
						$instance = new $class();
						$instance->register_wp_css();
						unset($class);
						unset($instance);
					}
					unset($render);
				}
			}
		}
		return $posts;
	}

        function action_admin_init() {
        // only hook up these filters if we're in the admin panel, and the current user has permission
        	if ( current_user_can( 'edit_posts' ) || current_user_can( 'edit_pages' ) ) {
			add_filter( 'mce_buttons', array($this,'filter_mce_button') );
			add_filter( 'mce_external_plugins', array($this,'filter_mce_plugin') );
			wp_enqueue_script( 'json2' );
		}
	 } 

	function config_admin_menu(){
		add_options_page('Gallery 3 Configuration','Gallery 3',9,basename(__FILE__),array($this,'admin_config_page') );
	}

	function filter_mce_button( $buttons ) {
		// add a separation before our button, here our button's id is &quot;mygallery_button&quot;
		array_push( $buttons, '|', 'heiv_gallery_3_button' );
		return $buttons;
	}

	function filter_mce_plugin( $plugins ) {
		// this plugin file will work the magic of our button
		$plugins['heiv_gallery_3'] = plugin_dir_url( __FILE__ ) . 'heiv_gallery_3_mce_editor.js';
		return $plugins;
	}

	function debug_settings() {
/*
		foreach($_POST as $k=>$v)
			echo '<br/>' . $k . '=' . $v;
*/
		echo '<style type="text/css">
				span.g3_picture {
					clear:left;
					display:block;
					text-align:center;
				}
			</style>';

		define('ERROR','<span style="color:red">Error</span> : ');
		if(isset($_POST['g3_host']) && $_POST['g3_host']!='') {
			$host = $_POST['g3_host'];
			$error = $guest = false;
			$ticket = $user = $password = null;
			$ret='';
			if($this->test_url($host)) {
				$ret.= NL . $host . ' is OK.' ;
				$guest = $_POST['g3_guest_access'];
				if($guest=='true'){
					if($this->test_url($host.'/rest/item/1')){
					}
					else{
						$ret.= HR . sprintf(__('Guest isn\'t allowed to make RESTFul query on this gallery3 - %s -)',$host));
						$error = true;
					}
				}
				else {
					if(isset($_POST['g3_user']) && $_POST['g3_user']!='') {
						$user = $_POST['g3_user'];
					}
					if(isset($_POST['g3_passwd']) && $_POST['g3_passwd']!='') {
						$password=$_POST['g3_passwd'];
					}
					if($password==''){
						$ret .= HR . __('Warning : Password is empty.').NL;
					}
					if($user!=''){
						$ticket = $this->get_ticket_g3($host.'/rest/',$user,$password);
						if( is_string($ticket)===true && $ticket != '') {
							$ret .= HR . sprintf(__('Get ticket for user <u>%s</u> : <i>%s</i>',$user,$ticket));
						}
						else{
							$ret .= HR . ERROR . sprintf(__('Are you sure that the user with the username "%s" can make restful query on %s ?<br/>Check the username and the password please and retry this test.'),$user,$host);
							$error = true;
						}
					}
					else {
						$ret .= HR . ERROR . __('User is empty, User must be set in order to retrieve a Gallery3 ticket.');
						$error = true;
					}
					$ticket_post = '';
					if(isset($_POST['g3_ticket_rest_api']) && $_POST['g3_ticket_rest_api']!='') {
						$ticket_post = $_POST['g3_ticket_rest_api'];
					}
					if($ticket !== $ticket_post){
						$ret .= HR . __('Warning : Ticket recently get from Gallery3 is not the same as save before.');
						$ret .= NL . sprintf(__('Saved ticket : %s') , $ticket_post);
						$ret .= NL . sprintf(__('Debug ticket : %s') , $ticket);

					}
				}	
				if($error==false) {
#					$ret .= HR . 'RESTFul API version : ' . $this->get_version_API($host);
					$root = $this->get_infos($host.'/rest/item/1',$ticket);
echo HR;
					$ret .= HR . 'Query Root Album of Gallery3 and get : ';
					$cover = $this->get_infos($root->entity->album_cover,$ticket);
					if($cover){
						$ret .= sprintf('<span class="g3_picture"><img src="%s"/><br/>Cover of Root Album</span>',$cover->entity->thumb_url_public);
					}
					$ret .= NL . 'Pictures in the Root Album :';
					foreach($root->members as $member_url){
						$member_data = $this->get_infos($member_url,$ticket);
						if($member_data){
							$ret .= sprintf('<span class="g3_picture"><img src="%s"/><br/>%s</span>',$member_data->entity->thumb_url_public,$member_data->entity->name);
						}
					}
				}
			}
			else {
				$ret .= NL . ERROR . $host . ' is <b><u>not</u></b> accessible. Stop testing here, check your configuration and fix it !';
				$error = true;
			}
		}
		else {
			$ret .= 'The value of "Host" is empty';
		}
		if($error==false)
			$ret .= NL . 'The settings seem to be OK';	
		$ret .= NL . NL . 'This is the end of tests.';
		echo '<h3>Testing of the settings</h3>' . $ret;
	}

	function get_options() {
		$options = array();
		foreach($_POST as $k=>$v)
			if(strpos(trim($k),'g3_')!==FALSE)
				$options[trim($k)]=trim($v);
return $options;
		if (isset($_POST['g3_host']) && $_POST['g3_host'] != "")
			$options['g3_host']  = strtolower($_POST['g3_host']);

		if (isset($_POST['g3_user']) )
			$options['g3_user'] = $_POST['g3_user'];
		else {
			$options['g3_user']='';
		}
/*
		if (isset($_POST['g3_guest_access']) )
			$options['g3_guest_access'] = $_POST['g3_guest_access']=='true';
		else {
			$options['g3_guest_access']=false;
		}
*/

		if (isset($_POST['g3_passwd']))
			$g3_passwd = $_POST['g3_passwd'];
		else {
			$g3_passwd='';
		}

		if ( isset($_POST['g3_height']) && $_POST['g3_height'] != '' )
			$options['g3_height'] = intval($_POST['g3_height']);
		else
			$options['g3_height'] = 300 ;
		
		if ( isset($_POST['g3_width']) && $_POST['g3_width'] != '' )
			$options['g3_width'] = intval($_POST['g3_width']);
		else
			$options['g3_width'] = 200;

		if ( isset($_POST['g3_delay']) && $_POST['g3_delay'] != '' )
			$options['g3_delay'] = intval($_POST['g3_delay']);
		else
			$options['g3_delay'] = 5000;

		if (isset($_POST['g3_infoPane'])) {
			$options['g3_infoPane'] = 'true';
		} else {
			$options['g3_infoPane'] = 'false';
		}

		if (isset($_POST['g3_textCaroussel']) && trim($_POST['g3_textCaroussel'] != ""))
			$options['g3_textCaroussel'] = trim($_POST['g3_textCaroussel']);

		if (isset($_POST['g3_showCaroussel'])) {
			$options['g3_showCaroussel'] = 'true';
		} else {
			$options['g3_showCaroussel'] = 'false';
		}

		if (isset($_POST['g3_directlink'])) {
			$options['g3_directlink'] = 'true';
		} else {
			$options['g3_directlink'] = 'false';
		}

		if (isset($_POST['g3_timed'])) {
			$options['g3_timed'] = 'true';
		} else {
			$options['g3_timed'] = 'false';
		}
		
		if (isset($_POST['g3_target'])) {
			$options['g3_target'] = $_POST['g3_target'];
		} else {
			$options['g3_target'] = '_blank';
		}
		if (isset($_POST['g3_ticket_rest_api']) && $g3_passwd=='') {
			$options['g3_ticket_rest_api'] = $_POST['g3_ticket_rest_api'];
		}
		else {
			$url_baserest=sprintf('%s%s',$options['g3_host'], '/rest/');
			if($this->options['g3_guest_access']==0 && $url_baserest!='') {
				$options['g3_ticket_rest_api'] = $this->get_ticket_g3($url_baserest,$options['g3_user'],$g3_passwd);
			}
		}
		return $options;
	}
	
	function admin_config_page(){
		if (!current_user_can('manage_options')) 
			die(__('You cannot edit the Gallery 3 options.'));
		$options = array();
		$action_buttons = isset( $_POST['action_buttons'] )?trim($_POST['action_buttons']):'';
		switch( $action_buttons ){
			case 'reset_settings':
				echo 'Reset settings';
				break;
			case 'debug_settings':
				$this->debug_settings();
				$options = $this->get_options();
				unset($this->options);
				$this->options = $options;
				break;
			case 'save_settings':
				$options = $this->get_options();
				$options['g3_valid_skins'] = $this->validate_skins(0);
				update_option('HeiVGallery3PP', $options);
				unset($this->options);
				$this->options = $options;
				break;
			case 'test_skins':
				$this->validate_skins(1);
			default:
				$this->options = get_option('HeivGallery3PP');
		}
	?>
		<div class="wrap">
			<script type="text/javascript">
				function help(ele1, ele2) {
					var expl = document.getElementById(ele2);
					if (expl.style.display == "block") {
						expl.style.display = "none";
						ele1.innerHTML = "(help)";
					} else {
						expl.style.display = "block";
						ele1.innerHTML = "(Hide help)";
					}
					return false;
				}
				function test_config_gallery3(){
					var host = jQuery('#g3_host').val();
					if(!host)
						host = '';
					var login='';
					var passwd='';
					var guest_access=jQuery('#g3_guest_access:checked').val();
					if(guest_access!='true'){
						login=jQuery('#g3_user').val();
						passwd=jQuery('#g3_passwd').val();
						if(!login)
							login='';
						if(!passwd)
							passwd='';
					}
					if(passwd==''){
						var confir=confirm("Are you sure to test the config with a null (or blank) password ?");
						if (confir==false) {
							return false;
						}
					}
					var data = { 
						host:host,
						guest:guest_access=='true',
						user:login,
						password:passwd,
						action: 'heiv_gallery_3_test_config'
					};
					jQuery.post(ajaxurl, data, function(response) {
						alert(response);
					});
				}

				function g3_set_guest() {
					var checkbox = jQuery("select#g3_guest_access").val();
					if(checkbox=='true'){
						jQuery("tr.ligne_no_guest").css('display','none');
					}
					else {
						jQuery("tr.ligne_no_guest").css('display','table-row');
					}

/*					var checkbox = jQuery("#g3_guest_access:checked").val();
					if(checkbox=='true'){
						jQuery("tr.ligne_no_guest").css('display','none');
					}
					else {
						jQuery("tr.ligne_no_guest").css('display','table-row');
					}
*/ 
				}
			</script>

			<h2>Gallery 3 Configuration</h2>
			<form action="" method="post" id="heiv_g3_conf">
				<table class="form-table" style="width:100%;">
					<tr>
						<td style="width:30%;">
							<label for="g3_host">Fully qualified domain name of the Gallery 3 website</label><br/><small><a href="#" onclick="return help(this, 'help_host');">(help)</a></small>
						</td>
						<td style="width:70%;">
							<input name="g3_host" id="g3_host" type="text" value="<?php echo $this->options['g3_host'];?>" maxlength="99" size="80"/>
						</td>
					</tr>
					<tr id="help_host" style="display:none;border:1px solid grey;">
						<td colspan="2">
							For instance :
							<ul>
								<li>http://gallery3.mydomain.com/</li>
								<li>http://gallery3.myotherdomain.com/index.php/</li>
							</ul>
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_user"><?php _e('Guest can query Gallery3 ?'); ?></label><br/><small><a href="#" onclick="return help(this, 'help_guest_access');">(help)</a></small>
						</td>
						<td>
							<select onchange="g3_set_guest()" id="g3_guest_access" name="g3_guest_access">
								<option value="true" <?php if($this->options['g3_guest_access']=='true') echo 'selected="selected" '; ?>><?php _e('Yes');?></option>
								<option value="false" <?php if($this->options['g3_guest_access']=='false') echo 'selected="selected" '; ?>><?php _e('No');?></option>
							</select>
<?/*
							<input type="checkbox" name="g3_guest_access" id="g3_guest_access" value="true" onclick="g3_set_guest()" <?php if($this->options['g3_guest_access']=='true') echo ' checked="checked" '; ?>/>
*/?>
						</td>
					</tr>
					<tr id="help_guest_access" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							In order to allow guest querying Restful's Gallery3, you have to read this documentation and apply the instructions : <a href="http://codex.gallery2.org/Gallery3:API:REST#Security_and_Authentication">Security and Authentication of Restful's Gallery3</a>
						</td>
					</tr>
					<tr class="ligne_no_guest">
						<td>
							<label for="g3_user">User for querying Gallery 3 Restful</label><br/><small><a href="#" onclick="return help(this, 'help_user');">(help)</a></small>
						</td>
						<td>
							<input name="g3_user" id="g3_user" type="text" value="<?php echo $this->options['g3_user']; ?>" maxlength="99" size="40"/>
						</td>
					</tr>
					<tr id="help_user" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							User for querying Restful's Gallery3 website
						</td>
					</tr>
					<tr class="ligne_no_guest">
						<td>
							<label for="g3_ticket_rest_api">Stored RESTFul API ticket</label><br/><small><a href="#" onclick="return help(this, 'help_ticket_rest_api');">(help)</a></small>
						</td>
						<td>
							<input name="g3_ticket_rest_api" id="g3_ticket_rest_api" type="text" value="<?php echo $this->options['g3_ticket_rest_api']; ?>" readonly="yes" size="40"/>
						</td>
					</tr>
					<tr id="help_ticket_rest_api" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							RESTFul API ticket will be used for query the RESTful Interface of Gallery3.<br/>If you want to change it, edit the user and the password and save the configuration.
						</td>
					</tr>	
					<tr class="ligne_no_guest">
						<td>
							<label for="g3_passwd">Password for querying Gallery3 Restful</label><br/><small><a href="#" onclick="return help(this, 'help_passwd');">(help)</a></small>
						</td>
						<td>
							<input name="g3_passwd" id="g3_passwd" type="text" value="" maxlength="99" size="40"/>
						</td>
					<tr id="help_passwd" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							Password of the user who can query Restful's Gallery3 website.
							<b> The password isn't store on the WP database !</b>
						</td>
					</tr>
					<tr id="help_render_single_img" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							User for querying Restful's Gallery3 website
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_render_single_img">Render fo single image</label><br/><small><a href="#" onclick="return help(this, 'help_render_single_img');">(help)</a></small>
						</td>
						<td>
							<select id="g3_render_single_img" name="g3_render_single_img">
<?php
	foreach($this->options['g3_valid_skins'] as $template) {
		printf('<option value="%1$s" %2$s>%1$s</option>',$template, $this->options['g3_render_single_img']==$template?'selected="seleted"':'');
	}
?>
							</select>
						</td>
					</tr>
					<tr id="help_ticket_rest_api" style="display:none;border:1px solid grey;"> 
						<td colspan="2">
							RESTFul API ticket will be used for query the RESTful Interface of Gallery3.<br/>If you want to change it, edit the user and the password and save the configuration.
						</td>
					</tr>	
<?php
	if($this->options['g3_guest_access']=='true')
		printf('<script type="text/javascript">g3_set_guest()</script>');
?>
				</table>
				<div id="tabs-config-skins">
			<h3>Skins Configuration</h3>
					<ul>
<?php
	foreach($this->options['g3_valid_skins'] as $template) {
		printf('<li><h4>%s</h4></li>',$template);
			require_once(dirname(__FILE__).'/skins/'.$template.'/'.$template.'.inc.php');
			$class_renderer = 'heiv_gallery_3_render_'.$template;
                        $renderer = new $class_renderer($this->options,null);
			echo $renderer->get_form_conf();
	}
?>
					</ul>
				</div>
				<p style="border:0;" class="submit">
<!--					<input type="button" name="test" value="Quick test Settings &raquo;" onclick="test_config_gallery3()"/>-->
					<input type="button" name="test_skins" value="Test skins &raquo;" onclick="jQuery('#hg3_hidden_action').val('test_skins');jQuery('#heiv_g3_conf').submit()"/>
					<input type="button" name="reset_settings" value="Undo modifications &raquo;" onclick="jQuery('#hg3_hidden_action').val('reset_settings');jQuery('#heiv_g3_conf').submit()"/>
					<input type="button" name="debug_settings" value="Test Settings &raquo;" onclick="jQuery('#hg3_hidden_action').val('debug_settings');jQuery('#heiv_g3_conf').submit()"/>
					<input type="submit" name="save_settings" value="Update Settings &raquo;" onclick="jQuery('#hg3_hidden_action').val('save_settings');jQuery('#heiv_g3_conf').submit()"/>
					<input type="hidden" name="action_buttons" value="" id="hg3_hidden_action"/>
				</p>
			</form>
		</div>

	<?php
	}

	function get_ticket_g3($url,$user,$pwd){
		$ticket='';
		if( $url!='' && $user!='' && $pwd!='') {

			$req = new HTTP_Request($url);

			$req->setMethod(HTTP_REQUEST_METHOD_POST);

			$req->addPostData('user',$user);
			$req->addPostData('password',$pwd);
			$req->addHeader('X-Gallery-Request-Method', 'post');

			$response = $req->sendRequest();

			if (PEAR::isError($response)) {
				//echo $response->getMessage();
			}
			else {
				$ticket = json_decode( $req->getResponseBody() );
			}
		}
		return $ticket;
	}

	function get_version_API($url){
		$version = null;
		if($url) {
			$req = new HTTP_Request($url.'/rest/item/1');
			$req->setMethod(HTTP_REQUEST_METHOD_GET);
			$req->addHeader("X-Gallery-Request-Key", $ticket);
			$req->addHeader("X-Gallery-Request-Method", 'get');
		
			$req->sendRequest();
			$head = $req->getResponseHeader();
			if($head && isset($head['x-gallery-api-version'])){
				$version = $head['x-gallery-api-version'];
			}
		}
		return $version;
	}
	
	function get_infos($url,$ticket='') {
		$ret=null;
		if($url) {
			$req = new HTTP_Request($url);
			$req->setMethod(HTTP_REQUEST_METHOD_GET);
			$req->addHeader("X-Gallery-Request-Key", $ticket);
			$req->addHeader("X-Gallery-Request-Method", 'get');
		
			$req->sendRequest();
			$ret = json_decode($req->getResponseBody());
		}
		return $ret;
	}

	function test_url($url,$ticket='') {
		$ret = false;
		if($url!=''){
			try {
				$req = new HTTP_Request($url);
				$req->setMethod(HTTP_REQUEST_METHOD_GET);
				$response = $req->sendRequest();
				if (PEAR::isError($response)) {
					return false;
				}
				else
				{
					return $req->getResponseCode()=='200';
				}
			}
			catch (Exception $e){
				$ret = false;
			}
		}
		return $ret;
	}

	function ajax_hg3_get_renderer() {
		
		$ret = json_encode(array('renderer'=>$this->options['g3_valid_skins']));
		echo $ret;
		die(); // it is normal to die here for ajax mode
	}

	function ajax_hg3_populate_tree_cb() {
		extract(shortcode_atts(array(
			'id' => '1',
			'limit' => 15,
			'start' => 0
		), $attrs));

		if(isset($_POST['id']) && $_POST['id']!='')
			$id = $_POST['id'];
		if(isset($_POST['limit']) && $_POST['limit']!='')
			$limit = $_POST['limit'];
		if(isset($_POST['start']) && $_POST['start']!='')
			$start = $_POST['start'];
		
		$url = sprintf('%s/rest/item/%d',$this->options['g3_host'],$id);

		$info = $this->get_infos($url,$this->options['g3_ticket_rest_api']);
		$ret = array();
		if($info){
			$ret['title'] = $info->entity->title;
			$ret['members'] = array();
			$ret['req'] = $id;
			$nb_photos = 0;
			$start_ = $start*$limit;
			$stop = ($start+1)*$limit;
			foreach($info->members as $member){
				$info_tmp = $this->get_infos($member,$this->options['g3_ticket_rest_api']);
				if($info_tmp){
					switch($info_tmp->entity->type){
						case 'album':
							array_push(
								$ret['members'],	array(	'id' 	=> $info_tmp->entity->id,
												'title' => $info_tmp->entity->name,
												'type'	=> $info_tmp->entity->type,
												'thumb'	=> $info_tmp->entity->thumb_url_public)
							);
						break;
						case 'photo':
							if($start_ <= $nb_photos && $nb_photos <$stop){
								array_push(
									$ret['members'],	array(	'id' 	=> $info_tmp->entity->id,
													'title' => $info_tmp->entity->name,
													'type'	=> $info_tmp->entity->type,
													'thumb'	=> $info_tmp->entity->thumb_url_public)
								);
							}
							$nb_photos++;
						break;
					}
				}
			}
			$ret['nb_photos'] = $nb_photos;
			$ret['nb_pages'] = ceil($nb_photos/$limit);
			$ret['pid'] = substr(strrchr($info->entity->parent, '/'), 1);
			$ret['req_p'] = $start;
		}
		else {
			$ret['error']=1;
		}
		$ret = json_encode($ret);
		echo $ret;
		die(); // it is normal to die here for ajax mode
	}

	function hg3_display($attrs,$content,$code) {

		extract(shortcode_atts(array(
			'target'=>'_blank',
			'id' => '1',
			'width' => $this->options['g3_width'],
			'height' => $this->options['g3_height'],
			'direct_link' => $this->options['g3_smoothgallery_directLink'], 
			'render' => 'smoothgallery'
		), $attrs));

		if(is_numeric($height)){
			$height.='px';
		}
		else {
			$height = $this->options['g3_height'].'px';
		}

		if(is_numeric($width)){
			$width.='px';
		}
		else {
			$width = $this->options['g3_width'].'px';
		}
		if($direct_link=='false' || $direct_link=='true') {
		}
		else {
			$direct_link = isset($this->options['g3_smoothgallery_directLink'])?$this->options['g3_smoothgallery_directLink']:'false';
		}

		$class_renderer = null;
		if( ! in_array($render,$this->valid_render) && is_file(dirname(__FILE__) . '/skins/'.$render.'inc.php') ){
			// default renderer
			$render = 'smoothgallery';
			$class_renderer = 'heiv_gallery_3_render_'.$render;
		}
		else {
			$class_renderer = 'heiv_gallery_3_render_'.$render;
		}
		
		if( isset($_REQUEST['target']) ) {
			$this->options['target'] = $_REQUEST['target'];
		}

		$str = '';
		$str_css='';

		$target_id = sprintf('%.9s',md5($url.$class_renderer));
		if( isset($this->options['target']) && $this->options['target'] == $target_id 
			&& isset($_REQUEST['id']) && is_numeric($_REQUEST['id'] ) ) {
			$id = $_REQUEST['id'];
		}

		$url = sprintf('%s/rest/item/%d',$this->options['g3_host'],$id);

		$nomtime=function_exists(microtime);
		$rdm_id = sprintf('%.6s',md5(($nomtime?microtime():time()).rand(0,100)));
		$this->options['rdm_id']=$rdm_id;
		$this->options['permalink'] = get_permalink( $wp_query->post->ID );
		
		$infos = $this->get_infos($url,$this->options['g3_ticket_rest_api']);

		if($infos && $class_renderer){
			require_once(dirname(__FILE__).'/skins/'.$render.'/'.$render.'.inc.php');
			$renderer = new $class_renderer($this->options,$attrs);
			switch($infos->entity->type){
				case 'album':
					if(sizeof($infos->members)>1 ){
						foreach($infos->members as $member){
							$info = $this->get_infos($member,$this->options['g3_ticket_rest_api']);
							if($info){
								$info->target = $target_id;
								$str .= $renderer->get_render( $info );
							}
						}
						$str_css = $renderer->get_js_gallery();
					}
					elseif (sizeof($infos->members)==1) {
						$info = $this->get_infos($infos->members[0],$this->options['g3_ticket_rest_api']);
						if($info){
							$class_renderer = 'heiv_gallery_3_render_'.$this->options['g3_render_single_img'];
							require_once(dirname(__FILE__).sprintf('/skins/%1$s/%1$s.inc.php',$this->options['g3_render_single_img']));
							$renderer = new $class_renderer($this->options,$attrs);
							$str_css = $renderer->get_css_photo();
							$str = $renderer->get_render($info);
						}
					}
					else {
						
						$str = __('This gallery is empty. <br/><a onclick="javascript:history.go(-1);return false;" href="#">Back.</a>');
					}
					break;
				case 'photo':
					$class_renderer = 'heiv_gallery_3_render_'.$this->options['g3_render_single_img'];
					require_once(dirname(__FILE__).sprintf('/skins/%1$s/%1$s.inc.php',$this->options['g3_render_single_img']));
					
					$renderer = new $class_renderer($this->options,$attrs);
					$str_css = $renderer->get_css_photo();
					$str = $renderer->get_render($infos);

					break;
			}
			$str = sprintf('%s<div id="gallery_%s">%s</div>',$str_css,$rdm_id,$str);
		}
		return $str;
	}

	function validate_skins($debug) {
		$valid_skins = array();
		$dir = dirname( __FILE__ ) . '/skins';
		if(is_dir($dir)) {
			if ($dh = opendir($dir)) {
				while (($file = readdir($dh)) !== false) {
					if( $file == '.' || $file == '..' )
						continue;
					else {
						$filename = $dir.'/'.$file.'/';
						if($debug)
							echo "<br/>======== skin : $file =========";
						$class = $filename.$file.'.inc.php';
						if(is_dir($filename) && is_file($class) ) {
							ob_start();
							readfile($class);
							$content_file = ob_get_contents();
							ob_end_clean();
							$ret = $this->validate_class($content_file);
							if( $ret['valid'] ) {
								if($debug)
									echo NL . __('skin ok.');
								array_push($valid_skins,$file);
							}
							else {
								if($debug) {
									echo NL . __('skin is not valid because : <ul style="list-style:disc inside none;">');
									foreach($ret['errors'] as $err) {
										vprintf('<li>'.$err['msg'].'</li>',$err['value']);
									}
									echo '</ul>';
								}
							}
							unset($ret);
						}
					}
				}
				closedir($dh);
			}
		}
		return $valid_skins;
	}

	function validate_class($str) {
		$valid = true;
		$errors = array();
		$matches=array();
// verification que la classe a valider est bien une heritiere de heiv_gallery_3_render
		if( preg_match_all( '#class(.*)extends(.*){#',$str,$matches ) ) {
			$class = trim($matches[1][0]);
			$parent = trim($matches[2][0]);
			unset($matches); $matches=array();
			if( $parent=='heiv_gallery_3_render') {
	// verification des fonctions minimales pour l utilisation du skin
				if( preg_match_all( '#function(.*)\((.*)\).*{#',$str,$matches ) ) {
					array_walk($matches[1], create_function('&$item,$key' ,' $item = trim($item);' ) );
					array_walk($matches[2], create_function('&$item,$key' ,' $item = trim($item);' ) );
					
					$diff = array_diff(array_keys($this->fct_required),$matches[1]);
					$inter_sec = array_intersect(array_keys($this->fct_required),$matches[1]);

					if(sizeof($inter_sec)!=sizeof($this->fct_required) ) {
						//array_push($errors,array('value'=>$diff,'msg'=>__('Methodes manquantes : %s' ) );
						array_push($errors,array('value'=>$diff,'msg'=>_n('Missing function : %s', 'Missing functions : %s',sizeof($diff) ) ) );
						$valid = false;
					}
		// verification du nombre de parametres des fonctions	
					for($i=0;$i<sizeof($matches[1]);$i++) {
						if( in_array($matches[1][$i],$inter_sec) ){
							$nb_params = $matches[2][$i]==''?0:sizeof(explode(',',$matches[2][$i]));
							if($nb_params!=$this->fct_required[$matches[1][$i]]) {
								array_push( $errors,array('value'=>array($matches[1][$i],$this->fct_required[$matches[1][$i]],sizeof(explode(',',$matches[2][$i])),$matches[2][$i]),'msg'=> __('Number of required variables for function %s : %s / number of getted variables from skin : %s  ( %s )' ) ) );
								$valid = false;
							}
						}
					}
				}
				else {
					array_push( $errors, array('value'=>array($class),'msg'=>__(' The skin %s doesn\'t declare the minimum required functions.' ) ) );
					$valid = false;
				}
			}
			else  {
				array_push( $errors, array('value'=>array($class,$parent),'msg'=> __(' The skin %s isn\'t a child of : heiv_gallery_3_render ( parent = %s ).' ) ) ) ;
				$valid = false;
			}
		}
		return array('valid'=>$valid,'errors'=>$errors);
	}

};

if($loading){
	$g3 = new heiv_gallery_3();
}
?>
